<template>
  <div class="form">
    <br>
    <div class="question">
      {{ $t('REG.NAME_LABEL') }} : {{ question.name }}
    </div>
    <br>
    <div class="answer">
      <div v-if="question.type =='객관'">
        {{ $t('LECTURE_LIST.TYPE') }}: {{ $t('QUESTION.MULTI_ANS') }}
        <br><br>
        {{ $t('QUESTION.QUESTION') }}: {{ question.question }}
        <br><br>
        <el-checkbox-group v-model="question.answer" size="small">
          <div v-for="(value) in question.choice" :key="value">
            <el-checkbox :label="value" border disabled></el-checkbox>
          </div>
        </el-checkbox-group>
        <br>
        {{ $t('RESULT.CRRT_ANSW') }}:
        <span v-for="(value) in answers" :key="value">{{ value + ' ' }}</span>
        <br>
      </div>
      <div v-if="question.type =='단답'">
        {{ $t('LECTURE_LIST.TYPE') }}: {{ $t('QUESTION.SHORT_ANS') }}
        <br><br>
        {{ $t('QUESTION.QUESTION') }}: {{ question.question }}
        <br>
        <br>
        {{ $t('RESULT.CRRT_ANSW') }}:
        <span v-for="(value) in question.answer" :key="value">{{ value + ' ' }}</span>
        <br>
      </div>

      <div v-if="question.type =='파일'">
        {{ $t('LECTURE_LIST.TYPE') }}: {{ $t('QUESTION.FILE') }}
        <br><br>
        <el-button @click="questionShow()">{{ $t('ITEM.PREVIEW') }}</el-button>
        <el-dialog :title="$t('ITEM.PREVIEW')" :visible.sync="preVisible" :before-close="handleClose" center
          width="30%">
          <quiz-preview :data="item" :onClick="onClick" />
          <template v-for="(item,index) in fileList">
            <!-- <div>{{ item.file_name}}</div> -->
            <div :key="index">
              <el-button @click="download(index)">{{ item.file_name }}</el-button>
            </div>
          </template>
          <youtube v-if="youtubeURL !== undefined && youtubeURL !== ''" player-width="100%" id="video"
            :video-id="youtubeId(youtubeURL)" :player-vars="{ autoplay: 1, modestbranding: 1 }" />
          <span slot="footer" class="dialog-footer">
            <el-button @click="handleClose">{{ $t('DASHBOARD.QUIT') }}</el-button>
          </span>
        </el-dialog>
        <br><br>
        {{ $t('HELP.EXPLANATION') }}: {{ question.question }}
        <br>
      </div>

      <!-- <br>
        {{ $t('QUESTION.KEYWORD') }}:
        <span v-for="(value) in studentQuestionKeywords" :key="value">{{ value.keyword }} : {{ value.score_portion}}{{ $t('LECTURE_MANAGE.SCORE') }} </span>
      <br><br> -->
      <br>
      <!-- 2020.06.05 과제 최대 점수 표시하는 부분  -->
      {{ $t('ASSIGNMENT.ASS_MAX_SCORE_STU') }}:
      <span>{{ maxScore }} </span>
      <br><br>
      <!-- <span v-for="(value,index) in score" :key="value">
        <el-button @click="onClick('SCORE',index)">{{ value }}</el-button>
      </span> -->
      <!-- 2020.06.05 점수 input으로 받기 -->
      <el-form>
        <el-form-item :label="$t('ASSIGNMENT.COMMENT')" v-if="commentVisible" style="margin: 0px;">
          <el-input v-model="comment" style="padding-bottom:10px; width:90%;"></el-input>
        </el-form-item>
        <el-form-item :label="$t('RESULT.SCORE')" style="margin: 0px;">
          <el-input-number v-model="score" size="small" :min="1" :max="maxScore" style="margin-right:10px;"></el-input-number>
          <el-button type="primary" size="small" @click="onClick('SCORE')"> {{ $t('NOTE.CONFIRM') }}</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
  import {
    mapState,
    mapActions,
    mapMutations
  } from 'vuex';
  import {
    getIdFromURL
  } from 'vue-youtube-embed';
  import lectureService from '../../services/lectureService';
  import studentService from '../../services/studentService';

  export default {
    // name: QuizEstimate,
    data() {
      return {
        homework: '',
        lectureId: 0,
        result: [],
        check: true,
        score: 0,
        answers: [],
        preVisible: false, // 미리보기용
        fileList: [],
        item: undefined,
        youtubes: [],
        youtubeURL: undefined,
        maxScore: null,
        comment: '',
        commentVisible: false,
      };
    },
    computed: {
      ...mapState('studentQuestion', [
        'studentQuestionKeywords', 'dialogVisible',
      ]),
    },
    watch: {
      question() {
        const vm = this;
        vm.result = [];
        vm.answers = [];
        vm.youtubes = [];
        if (vm.question.type === '객관') {
          const answer = vm.question.answer;
          const choice = vm.question.choice;
          for (let i = 0; i < choice.length; i += 1) {
            if (answer.includes((i + 1).toString())) {
              const obj = {
                choice: choice[i],
                check: true
              };
              vm.answers.push(`${i + 1}번`);
              vm.result.push(obj);
            } else {
              const obj = {
                choice: choice[i],
                check: false
              };
              vm.result.push(obj);
            }
          }
        } else if (vm.question.type === '파일') {
          const ytb = vm.question.answer;
          vm.youtubes.push(ytb);
        }
        // alert(`keywords - ${JSON.stringify(vm.studentQuestionKeywords)}`);
      },
    },
    async mounted() {
      const vm = this;
      vm.result = [];
      vm.answers = [];
      if (vm.question.type === '객관') {
        const answer = vm.question.answer;
        const choice = vm.question.choice;
        for (let i = 0; i < choice.length; i += 1) {
          if (answer.includes((i + 1).toString())) {
            const obj = {
              choice: choice[i],
              check: true
            };
            vm.answers.push(`${i + 1}번`);
            vm.result.push(obj);
          } else {
            const obj = {
              choice: choice[i],
              check: false
            };
            vm.result.push(obj);
          }
        }
      } else if (vm.question.type === '파일') {
        const ytb = vm.question.answer;
        vm.youtubes.push(ytb);
      }
    },
    async created() {
      const vm = this;
      vm.lectureId = vm.$route.query.lectureId * 1;
      const homework = await lectureService.getLectureHomework({
        lectureId: vm.lectureId
      });
      vm.homework = homework.data;
      vm.maxScore = vm.homework[0].max_score;
      vm.commentVisible = vm.homework[0].comment;
      vm.score = vm.maxScore;
    },
    methods: {
      ...mapActions('studentQuestion', ['postStudentQuestionScore']),
      ...mapMutations('studentQuestion', ['updateDialogVisible']),
      youtubeId(URL) {
        return URL !== undefined ? getIdFromURL(URL) : '';
      },
      async onClick(type) {
        const vm = this;
        switch (type) {
          case 'SCORE': {
            if (vm.question.estimated != undefined) {
              // 2020.05.22 이제 수정하면 기존 것 삭제하고 다시 들감
              if (vm.question.estimated === '완료') {
                await studentService.deleteStudentQuestionScore({
                  id: vm.question.lecture_id,
                  qId: vm.question.student_question_id,
                });
                await vm.postStudentQuestionScore({
                  id: vm.question.lecture_id,
                  qId: vm.question.student_question_id,
                  score: vm.score,
                  comment: vm.comment,
                });
                vm.updateDialogVisible({
                  value: false
                });
              } else {
                await vm.postStudentQuestionScore({
                  id: vm.question.lecture_id,
                  qId: vm.question.student_question_id,
                  score: vm.score,
                  comment: vm.comment,
                });
                vm.updateDialogVisible({
                  value: false
                });
              }
            }
            // break;
          }
          default: {
            break;
          }
        }
      },
      handleClose() {
        const vm = this;
        vm.preVisible = false;
        vm.item = undefined;
        vm.youtubeURL = undefined;
      },
      async questionShow() {
        const vm = this;
        const thisItem = {};
        thisItem.questions = [];
        thisItem.questions.push(vm.question);
        const files = await lectureService.studentQuestionFileList({
          questionId: vm.question.student_question_id,
          lectureId: vm.question.lecture_id,
        });
        vm.fileList = files.data;
        vm.item = thisItem;
        // 유튜브 주소를 여기서 가져오도록 수정
        // 유튜브 주소를 object type으로 가져오는 경우 있어서 항상 string type으로 수정 - 200909
        vm.youtubeURL = thisItem.questions[0].answer.toString();
        vm.preVisible = true;
      },
      async download(index) {
        const vm = this;
        const obj = vm.fileList[index];
        window.open(obj.file_url);
      },
    },
    props: ['question'],
  };
</script>
<style>
  .question {
    background-color: blanchedalmond;
  }

  .form {
    background-color: #e5e9f2;
  }

  .el-form {
    margin: 0px;
  }
</style>